#ifndef ASTAR_LIBASTAR_H
#define ASTAR_LIBASTAR_H
#include "../world.hpp"

typedef std::vector<std::vector<Node*>> nodeMatrix;
typedef std::vector<Node*> nodeList;

class LibAstar {
private:
    Node* start;
    Node* end;
    nodeMatrix* map;
public:
    nodeList open_list;
    nodeList closed_list;
    nodeList path;
    explicit LibAstar(nodeMatrix* map);
    nodeList findPath();
    nodeList findChildren(Node* pNode);
    static bool isNodeOnList(Node* pNode, const nodeList& vector1);
    static int findPlace(Node* pNode, nodeList vector);
    static Node* findLowestCostNode(const nodeList& vector);
};

int verifyPath(nodeMatrix* map, nodeList* path, nodeList* astarPath);
void printPath(nodeMatrix * map, nodeList* path, nodeList* openList, nodeList* closedList);


#endif //ASTAR_LIBASTAR_H
