#include "world.hpp"
#include <iostream>
#include "libAstar/libastar.h"
#include "astar.hpp"
#include <cstdlib>

int main() {
    std::cout << "\033[34mInitialisation \033[0m" << std::endl;
    nodeList result;
    nodeMatrix map;
    int tentative = 0;
    int obstacle = 100;
    while (result.empty()) {
        std::cout << "Construction de la carte" << std::endl;
        map = createMap(100, 100, obstacle , false);
        std::cout << "Densité des obstacles : " << density(&map) << std::endl;
        auto* libAstar = new LibAstar(&map);
        result = libAstar->findPath();
//        printPath(&map, &result, &libAstar->open_list, &libAstar->closed_list);
        if (result.empty() && tentative < 100) {
            tentative++;
            std::cout << "Aucune solution possible, génération d'une nouvelle carte" << std::endl;
            deleteMap(&map);
            obstacle = obstacle - 5 > 0 ? obstacle - 5 : 0;
        } else if (tentative < 100) {
            std::cout << "Solution possible" << std::endl;
        } else {
            std::cout << "Aucune solution possible, changer la densité d'obstacles" << std::endl;
            exit(0);
        }
        delete libAstar;
    }
    std::cout << "\033[34mFin de l'initialisation \033[0m" << std::endl;
    std::cout << "\033[34mRecherche de chemin \033[0m" << std::endl;
    Astar astar = Astar(&map);
    astar.initialize();
    astar.findPath();
    std::cout << "\033[34mFin de la recherche de chemin \033[0m" << std::endl;
    std::cout << "\033[34mVérification de la solution \033[0m" << std::endl;
    int state = verifyPath(&map, &astar.path, &result);
    if (state == 0) {
        std::cout << "\033[33mSolution correcte \033[0m" << std::endl;
    } else {
        std::cout << "\033[31mSolution incorrecte \033[0m" << std::endl;
    }
    printPath(&map, &astar.path, &astar.open_list, &astar.closed_list);
    deleteMap(&map);
    return 0;
}
